ProvenanceResource
RESTful endpoint for querying data provenance.
The following resources are applicable:
- /controller/provenance
- /controller/provenance/{id}
- /controller/provenance/events/{id}
- /controller/provenance/events/{id}/content/input
- /controller/provenance/events/{id}/content/output
- /controller/provenance/lineage
- /controller/provenance/lineage/{id}
- /controller/provenance/replays
- /controller/provenance/search-options
/controller/provenance
Mount Point: /rest/controller/provenance
POST
Creates provenance using the specified query criteria.
Parameters
| name | description | type | default |
|---|---|---|---|
| clientId | Optional client id. If the client id is not specified, a new one will be generated. This value (whether specified or generated) is included in the response. | form | |
| startDate | The start date. | form | |
| endDate | The end date. | form | |
| minimumFileSize | The minimum size of the content after the event. | form | |
| maximumFileSize | The maximum size of the content after the event. | form | |
| maxResults | The maximum number of results to return. | form | |
| clusterNodeId | The id of node in the cluster to search. This is optional and only relevant when clustered. If clustered and it is not specified the entire cluster is searched. | form |
Request Body
| element: | formParams |
| media types: | */* application/xml |
Additionally, the search parameters are specified in
the form parameters. Because the search parameters differ based on
configuration they are specified in a map-like fashion:
- search[filename]=myFile.txt
- search[eventType]=RECEIVED
Response Body
| element: | provenanceEntity |
| media types: | application/xml application/json |
A provenanceEntity
POST
Creates provenance using the specified query criteria.
Request Body
| element: | provenanceEntity |
| media types: | application/xml application/json |
A provenanceEntity
Response Body
| element: | provenanceEntity |
| media types: | application/xml application/json |
A provenanceEntity
/controller/provenance/{id}
Mount Point: /rest/controller/provenance/{id}
GET
Gets the provenance with the specified id.
Parameters
| name | description | type | default |
|---|---|---|---|
| clientId | Optional client id. If the client id is not specified, a new one will be generated. This value (whether specified or generated) is included in the response. | query | |
| clusterNodeId | The id of node in the cluster to search. This is optional and only relevant when clustered. If clustered and it is not specified the entire cluster is searched. | query | |
| id | The id of the provenance | path |
Response Body
| element: | provenanceEntity |
| media types: | application/xml application/json |
A provenanceEntity
DELETE
Deletes the provenance with the specified id.
Parameters
| name | description | type | default |
|---|---|---|---|
| clientId | Optional client id. If the client id is not specified, a new one will be generated. This value (whether specified or generated) is included in the response. | query | |
| clusterNodeId | The id of node in the cluster to search. This is optional and only relevant when clustered. If clustered and it is not specified the entire cluster is searched. | query | |
| id | The id of the provenance | path |
Response Body
| element: | provenanceEntity |
| media types: | application/xml application/json |
A provenanceEntity
/controller/provenance/events/{id}
Mount Point: /rest/controller/provenance/events/{id}
GET
Gets the details for a provenance event.
Parameters
| name | description | type | default |
|---|---|---|---|
| clientId | Optional client id. If the client id is not specified, a new one will be generated. This value (whether specified or generated) is included in the response. | query | |
| clusterNodeId | The id of node in the cluster that the event/flowfile originated from. This is only required when clustered. | query | |
| id | The id of the event | path |
Response Body
| element: | provenanceEventEntity |
| media types: | application/xml application/json |
A provenanceEventEntity
/controller/provenance/events/{id}/content/input
Mount Point: /rest/controller/provenance/events/{id}/content/input
GET
Gets the content for the input of the specified event.
Parameters
| name | description | type | default |
|---|---|---|---|
| clientId | Optional client id. If the client id is not specified, a new one will be generated. This value (whether specified or generated) is included in the response. | query | |
| clusterNodeId | The id of the node within the cluster this content is on. Required if clustered. | query | |
| id | The id of the provenance event associated with this content. | path |
Response Body
| element: | (custom) |
| media types: | application/octet-stream |
The content stream
/controller/provenance/events/{id}/content/output
Mount Point: /rest/controller/provenance/events/{id}/content/output
GET
Gets the content for the output of the specified event.
Parameters
| name | description | type | default |
|---|---|---|---|
| clientId | Optional client id. If the client id is not specified, a new one will be generated. This value (whether specified or generated) is included in the response. | query | |
| clusterNodeId | The id of the node within the cluster this content is on. Required if clustered. | query | |
| id | The id of the provenance event associated with this content. | path |
Response Body
| element: | (custom) |
| media types: | application/octet-stream |
The content stream
/controller/provenance/lineage
Mount Point: /rest/controller/provenance/lineage
POST
Submits a lineage request based on an event or a flowfile uuid. When querying for the lineage of an event you must specify the eventId and the eventDirection. The eventDirection must be 'parents' or 'children' and specifies whether we are going up or down the flowfile ancestry. The uuid cannot be specified in these cases. When querying for the lineage of a flowfile you must specify the uuid. The eventId and eventDirection cannot be specified in this case.
Parameters
| name | description | type | default |
|---|---|---|---|
| clientId | Optional client id. If the client id is not specified, a new one will be generated. This value (whether specified or generated) is included in the response. | form | |
| lineageRequestType | Either 'PARENTS', 'CHILDREN', or 'FLOWFILE'. PARENTS will return the lineage for the flowfiles that are parents of the specified event. CHILDREN will return the lineage of for the flowfiles that are children of the specified event. FLOWFILE will return the lineage for the specified flowfile. | form | |
| eventId | The id of an event to get the lineage for. Must also specify the eventDirection and not the uuid. | form | |
| uuid | The uuid of the flowfile to get the lineage for. Must not specify the eventId or eventDirection. | form | |
| clusterNodeId | The id of node in the cluster that the event/flowfile originated from. This is only required when clustered. | form |
Response Body
| element: | lineageEntity |
| media types: | application/xml application/json |
A lineageEntity
POST
Submits a lineage request based on an event or a flowfile uuid. When querying for the lineage of an event you must specify the eventId and the eventDirection. The eventDirection must be 'parents' or 'children' and specifies whether we are going up or down the flowfile ancestry. The uuid cannot be specified in these cases. When querying for the lineage of a flowfile you must specify the uuid. The eventId and eventDirection cannot be specified in this case.
Request Body
| element: | lineageEntity |
| media types: | application/xml application/json |
A lineageEntity
Response Body
| element: | lineageEntity |
| media types: | application/xml application/json |
A lineageEntity
/controller/provenance/lineage/{id}
Mount Point: /rest/controller/provenance/lineage/{id}
GET
Gets the lineage with the specified id.
Parameters
| name | description | type | default |
|---|---|---|---|
| clientId | Optional client id. If the client id is not specified, a new one will be generated. This value (whether specified or generated) is included in the response. | query | |
| clusterNodeId | The id of node in the cluster that the event/flowfile originated from. This is only required when clustered. | query | |
| id | The id of the lineage | path |
Response Body
| element: | lineageEntity |
| media types: | application/xml application/json |
A lineageEntity
DELETE
Deletes the lineage with the specified id.
Parameters
| name | description | type | default |
|---|---|---|---|
| clientId | Optional client id. If the client id is not specified, a new one will be generated. This value (whether specified or generated) is included in the response. | query | |
| clusterNodeId | The id of node in the cluster that the event/flowfile originated from. This is only required when clustered. | query | |
| id | The id of the lineage | path |
Response Body
| element: | lineageEntity |
| media types: | application/xml application/json |
A lineageEntity
/controller/provenance/replays
Mount Point: /rest/controller/provenance/replays
POST
Creates a new replay request for the content associated with the specified provenance event id.
Parameters
| name | description | type | default |
|---|---|---|---|
| clientId | Optional client id. If the client id is not specified, a new one will be generated. This value (whether specified or generated) is included in the response. | form | |
| clusterNodeId | The id of the node in the cluster that has the specified event. Required if clustered. | form | |
| eventId | The provenance event id. | form |
Response Body
| element: | provenanceEventEntity |
| media types: | application/xml application/json |
A provenanceEventEntity
/controller/provenance/search-options
Mount Point: /rest/controller/provenance/search-options
GET
Gets the provenance search options for this NiFi.
Parameters
| name | description | type | default |
|---|---|---|---|
| clientId | Optional client id. If the client id is not specified, a new one will be generated. This value (whether specified or generated) is included in the response. | query |
Response Body
| element: | provenanceOptionsEntity |
| media types: | application/xml application/json |
A provenanceOptionsEntity